/*
 *  Copyright (C) 2002  Harald Barth, Stockholm, Sweden.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 */

typedef struct locostruct{
  char *protocol;
  int addr;
  int direction;
  int v;
  int v_max;
  int func;
  int nro_f;
  int f[8];
  struct locostruct *next;
  int enslaved;
  int master;
  int valid;
} Loco;

int locoUpdate(Loco *loco, int direction, 
		int v, int vmax, int func, int nro_f, int *f);
void locoComposeMessage(char *locomessage, int msglen, Loco *loco);
Loco *locoGet(char *protocol, int addr);
int locoIsMaster(Loco *loco);
Loco *locoAddMaster(char *protocol, int addr);
Loco *locoAddSlave(char *protocol, int addr);
void locoAddSlaveToMaster(Loco *master, Loco *slave);
void locoAddAllSlavesToMaster(Loco *master);

