%{

/*
 *  Copyright (C) 2002  Harald Barth, Stockholm, Sweden.
 *  Copyright (C) 2000  Torsten Vogt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This file contains portions of srcp-flex.l Copyright (C) 2000 
 *  Torsten Vogt and was derived 2002-01-01.
 */
#include "consist.h"
RCSID("$Id: srcp-flex.l,v 1.2 2002/01/06 09:06:00 haba Exp $");

#include <stdlib.h>
#include <string.h>

#include "srcp-global.h"
#include "srcp-yacc.h"

#define YY_NO_UNPUT
int yywrap(void) { return 1; }

#define YY_DECL int yylex(YYSTYPE *yylval) /* this makes the scanner multi-
                                              threadable */

%}
%%
[ \t\r]+       ; /* ignore whitespace */
[\n]           { return tokCMDEND;       }
"SHUTDOWN"     { return tokSHUTDOWN;     }
"LOGOUT"       { return tokLOGOUT;       }
"STARTVOLTAGE" { return tokSTARTVOLTAGE; }
"STOPVOLTAGE"  { return tokSTOPVOLTAGE;  }
"RESET"        { return tokRESET;        }
"SET"          { return tokSET;          }
"GET"          { return tokGET;          }
"WAIT"         { return tokWAIT;         }
"INIT"         { return tokINIT;         }
"TERM"         { return tokTERM;         }
"WRITE"        { return tokWRITE;        }
"VERIFY"       { return tokVERIFY;       }
"GL"           { return tokGL;           }
"GA"           { return tokGA;           }
"FB"           { return tokFB;           }
"TIME"         { return tokTIME;         }
"POWER"        { return tokPOWER;        }
"INFO"         { return tokINFO;         }
"S88"          { strcpy(yylval->strval,"S88");   return tokMODULTYPE; }
"I8255"        { strcpy(yylval->strval,"I8255"); return tokMODULTYPE; }
"M6051"        { strcpy(yylval->strval,"M6051"); return tokMODULTYPE; } 
"NMRA"         { strcpy(yylval->strval,"NMRA"); return tokPROTOCOL; } 
"M"            { strcpy(yylval->strval,"M"); return tokPROTOCOL;  }
"N"            { strcpy(yylval->strval,"N"); return tokPROTOCOL;  }
"M1"           { strcpy(yylval->strval,"M1"); return tokPROTOCOL; }
"M2"           { strcpy(yylval->strval,"M2"); return tokPROTOCOL; }
"M3"           { strcpy(yylval->strval,"M3"); return tokPROTOCOL; }
"M4"           { strcpy(yylval->strval,"M4"); return tokPROTOCOL; }
"M5"           { strcpy(yylval->strval,"M5"); return tokPROTOCOL; }
"MF"           { strcpy(yylval->strval,"MF"); return tokPROTOCOL; }
"NB"           { strcpy(yylval->strval,"NB"); return tokPROTOCOL; }
"N1"           { strcpy(yylval->strval,"N1"); return tokPROTOCOL; }
"N2"           { strcpy(yylval->strval,"N2"); return tokPROTOCOL; }
"N3"           { strcpy(yylval->strval,"N3"); return tokPROTOCOL; }
"N4"           { strcpy(yylval->strval,"N4"); return tokPROTOCOL; }
"PS"           { strcpy(yylval->strval,"PS"); return tokPROTOCOL; }
"ON"           { return tokON;                                    }
"OFF"          { return tokOFF;                                   }
\*             { yylval->numval=-1; return tokVALUE; }
[-]{0,1}[0-9]+ { yylval->numval=strtol(yytext,NULL,10); return tokVALUE; }
"CV"           { strcpy(yylval->strval,"CV");    return tokDESTTYPE; }
"CVBIT"        { strcpy(yylval->strval,"CVBIT"); return tokDESTTYPE; }
"REG"          { strcpy(yylval->strval,"REG");   return tokDESTTYPE; }
.              { return tokNOTHING; }
%%
void srcp_setbuffer(char *b) {
   yy_scan_string(b);
}
