%{
/*
 *  Copyright (C) 2002  Harald Barth, Stockholm, Sweden.
 *  Copyright (C) 2000  Torsten Vogt
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This file contains portions of srcp-yacc.y Copyright (C) 2000 
 *  Torsten Vogt and was derived 2002-01-01.
 */
#include "consist.h"
RCSID("$Id: srcp-yacc.y,v 1.2 2002/01/06 09:06:00 haba Exp $");

#include <stdlib.h>
#include <stdio.h>
#include <syslog.h>
#include "srcp-global.h"
/*#include "srcp.h"*/
#include "handler.h"

#define YYPURE   /* we need a parser in a multi threaded environment */
#define YYPARSE_PARAM sckt /* we need an argument */

int yyerror(char *s) {
   /* write parse errors to syslog and ignore them */
  /* syslog(LOG_INFO, "   SRCP syntax error");*/
  fprintf(stderr, "yyerror: %s\n", s);
   return 0;
} 

/* some variables for temporarie values */
int f_nr=0;  /* number of extra functions */
int f[8];    /* values of the exgtra functions, max. 8 */

%}
%start cmds

%token tokNOTHING      01

%token tokCMDEND       05

%token tokSHUTDOWN     10
%token tokLOGOUT       11
%token tokSTARTVOLTAGE 12
%token tokSTOPVOLTAGE  13
%token tokRESET        14

%token tokSET          21
%token tokGET          22
%token tokWAIT         23
%token tokINIT         24
%token tokTERM         25
%token tokWRITE        26
%token tokVERIFY       27

%token tokGL           31
%token tokGA           32
%token tokFB           33
%token tokTIME         35
%token tokPOWER        36

%token tokINFO         41

%token tokVALUE        51
%token tokMODULTYPE    52
%token tokPROTOCOL     53
%token tokDESTTYPE     54

%token tokON           61
%token tokOFF          62

%%
cmds    : cmd tokCMDEND cmds
        | cmd tokCMDEND
        ;
cmd     : tokSHUTDOWN
        | tokLOGOUT
        | tokSTARTVOLTAGE
        | tokSTOPVOLTAGE
        | tokRESET
        | tokSET tokGL tokPROTOCOL tokVALUE tokVALUE tokVALUE tokVALUE tokVALUE
          tokVALUE fvalues
        | tokSET tokGA tokPROTOCOL tokVALUE tokVALUE tokVALUE tokVALUE
        | tokSET tokTIME tokVALUE tokVALUE tokVALUE tokVALUE tokVALUE tokVALUE
        | tokSET tokPOWER tokON 
        | tokSET tokPOWER tokOFF
        | tokGET tokGL tokPROTOCOL tokVALUE
        | tokGET tokGA tokPROTOCOL tokVALUE tokVALUE
        | tokGET tokFB tokMODULTYPE tokVALUE
        | tokGET tokTIME
        | tokGET tokPOWER
        | tokWAIT tokFB tokMODULTYPE tokVALUE tokVALUE tokVALUE
        | tokWAIT tokTIME tokVALUE tokVALUE tokVALUE tokVALUE
        | tokINIT tokFB tokMODULTYPE
        | tokINIT tokTIME tokVALUE tokVALUE tokVALUE tokVALUE tokVALUE tokVALUE
        | tokTERM
        | tokINFO tokGL tokPROTOCOL tokVALUE tokVALUE tokVALUE tokVALUE
          tokVALUE tokVALUE { f_nr = 0; } fvalues
          { handleINFO((int)sckt, $3.strval, $4.numval, $5.numval, $6.numval, $7.numval,
	       $8.numval, $9.numval, f);
	  }
        | tokINFO tokGA tokPROTOCOL tokVALUE tokVALUE tokVALUE
        | tokINFO tokFB tokMODULTYPE tokVALUE tokVALUE
        | tokINFO tokVALUE
        | tokWRITE tokGL tokPROTOCOL tokDESTTYPE tokVALUE tokVALUE
        | tokWRITE tokGA tokPROTOCOL tokDESTTYPE tokVALUE tokVALUE
        | tokWRITE tokGL tokPROTOCOL tokDESTTYPE tokVALUE tokVALUE tokVALUE
        | tokWRITE tokGA tokPROTOCOL tokDESTTYPE tokVALUE tokVALUE tokVALUE
        | tokVERIFY tokGL tokPROTOCOL tokDESTTYPE tokVALUE tokVALUE
        | tokVERIFY tokGA tokPROTOCOL tokDESTTYPE tokVALUE tokVALUE
        ;
fvalues : tokVALUE { f[f_nr]=$1.numval; f_nr++; } fvalues
        | /* empty */
        ;
%%
int srcp_parse(int sckt) {
   return yyparse((void*)sckt);
} 
